unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ScktComp, ComCtrls, HPropGrid, ExtCtrls, RegExpr;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Edit2: TEdit;
    Memo1: TMemo;
    Button1: TButton;
    Button2: TButton;
    ClientSocket1: TClientSocket;
    StatusBar1: TStatusBar;
    RadioGroup1: TRadioGroup;
    RadioGroup2: TRadioGroup;
    Button3: TButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Edit3: TEdit;
    CheckBox3: TCheckBox;
    Edit4: TEdit;
    Edit5: TEdit;
    Label3: TLabel;
    Label4: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);

    procedure ClientSocket1Connect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure ClientSocket1Read(Sender: TObject; Socket: TCustomWinSocket);
    procedure ClientSocket1Disconnect(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Button3Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;
  FData: TMemoryStream;
  httpMethod : string ;
  httpVer    : string ;
  httpPort   : string ;
  httpPath   : string ;
  httpHost     : string ;
  proxyPort  : string ;
  proxyHost  : string ;
  outString  : string ;

implementation

{$R *.dfm}

// 3oCgf[^̕яς
function exchange_0_2(Src: DWORD): DWORD;
type
  TTemp = array[0..3]of BYTE;
begin
  Result := Src;
  TTemp(Result)[2] := TTemp(Src)[0];
  TTemp(Result)[0] := TTemp(Src)[2];
end;

// base64`ŃGR[h
function base64encode(Src: Pointer; Len: Integer): string;
const
  Table: PChar =
'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/';
var
  I: Integer;

  function doNbyte(N: Integer): string;
  var
    Value: DWORD;
    Dst: array[0..3]of Char;
    I: Integer;
  begin
    if not(N in [1..3]) then Exit;
    FillChar(Dst, sizeof(Dst), 0);
    // NoCgǂݍŁAѕς
    Move(PBYTE(Src)^, Value, N);
    Inc(Integer(Src), N);
    Value := exchange_0_2(Value);
    // 6rbgɕϊ
    for I := 3 downto 0 do
    begin
      if I > N then
        Dst[I] := '=' // ϊΏۊÓe=fŃpfBO
      else Dst[I] :=
        Table[Value and $3f];
      Value := Value shr 6;
    end;
    // ϊf[^(4)Ԃ
    SetString(Result, Dst, 4);
  end;

begin
  Result := '';
  for I := 0 to Len div 3 - 1 do
    Result := Result + doNbyte(3);

  // 3̔{oCg]f[^
  if (Len mod 3) > 0 then
    Result := Result + doNbyte(Len mod 3);
end;

//Fؗp̕񐶐
function authstr(AuthID: String; AuthPW: String): string;
var
  ReadSize : Integer;
  Buffer: Pointer;
  BaseStr: String;
begin
    BaseStr := AuthID + ':' + AuthPW ;
    Buffer := PChar(BaseStr);
    ReadSize := StrLen(Buffer);
    Result := base64encode(Buffer, ReadSize);
end;


procedure TForm1.Button1Click(Sender: TObject);

begin
  // ɐڑĂAUڑ؂
  ClientSocket1.Active := FALSE;

  //ڑ`
  if proxyHost = '' then
  begin
    ClientSocket1.Host := httpHost;
    ClientSocket1.Port := StrToInt(httpPort)
  end
  else
  begin
    ClientSocket1.Host := proxyHost;
    ClientSocket1.Port := StrToInt(proxyPort)
  end;

  // \Pbgڑ
  ClientSocket1.Active := TRUE;

  outString := '';

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  Memo1.Clear;
end;

procedure TForm1.ClientSocket1Connect(Sender: TObject;
  Socket: TCustomWinSocket);
begin

  // T[oɑv𐶐
  if RadioGroup1.ItemIndex = 0 Then
    httpMethod := 'GET '
  else if RadioGroup1.ItemIndex = 2 Then
    httpMethod := 'OPTIONS '
  else if RadioGroup1.ItemIndex = 3 Then
    httpMethod := 'TRACE '
  else
    httpMethod := 'HEAD ';

  if RadioGroup2.ItemIndex = 0 Then
    httpVer := ' HTTP/1.0'
  else
    httpVer := ' HTTP/1.1';

  if proxyHost = '' then
    outString := outString + httpMethod + httpPath + httpVer +#13#10
  else
    outString := outString + httpMethod + Edit1.Text + httpVer +#13#10;

  outString := outString + 'Host: ' + httpHost +#13#10;
  if RadioGroup2.ItemIndex = 1 then // HTTP 1.1 ̂Ƃ
    outString := outString + 'Connection: close' +#13#10;
  if CheckBox1.Checked then
    outString := outString + 'User-Agent: Mozilla/4.0 (compatible; MSIE 5.0; Windows 98)' +#13#10;
  if CheckBox2.Checked then
    outString := outString + 'Accept-Language: ' + Edit3.Text +#13#10;
  if CheckBox3.Checked then
    outString := outString + 'Authorization: Basic ' + authstr(Edit4.Text,Edit5.Text) +#13#10;
  outString := outString + #13#10;

  // T[o[ɃhLg̑Mv
  Socket.SendText(outString);

  // mʕ\
  Memo1.Lines.Append( '-------> ConnectTo '
                                    + ClientSocket1.Host
                                    +':'+ IntToStr(ClientSocket1.Port) + #13#10 );
  Memo1.Lines.Append( outString );
  Memo1.Lines.Append( '<-------' + #13#10 );

end;

procedure TForm1.ClientSocket1Read(Sender: TObject;
  Socket: TCustomWinSocket);

begin
  // Mf[^ string ^Ŏ󂯎ʕ\
  Memo1.Lines.Append( Socket.ReceiveText );

end;

procedure TForm1.ClientSocket1Disconnect(Sender: TObject;
  Socket: TCustomWinSocket);
begin
  //ؒfɕ\镶
  Memo1.Lines.Append( '========' + #13#10 );
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  //Close{^Ƃ
  ClientSocket1.Active := FALSE;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
  Edit1.SetFocus;
end;

procedure TForm1.Edit1Change(Sender: TObject);
var
  re: TRegExpr;

begin

  //URL
  re := nil;
  re := TRegExpr.Create;
  re.Expression := '(http:)?(//)?([^:/]*)?(:([0-9]+)?)?(/.*)?';
  try
    if re.Exec(Edit1.Text) then
    begin
      if re.Match[3] <> '' then httpHost := re.Match[3];
      if re.Match[5] <> '' then httpPort := re.Match[5] else httpPort := '80';
      if re.Match[6] <> '' then httpPath := re.Match[6] else httpPath := '/';
    end;
  except
  end;

  //URLʕ\
  StatusBar1.SimpleText := 'Host: '+ httpHost + ':' + httpPort + ' Path: ' + httpPath;

  //proxy
  re.Expression := '([^:/]*)?(:([0-9]+)?)?';
  try
    if re.Exec(Edit2.Text) then
    begin
      if re.Match[1] <> '' then proxyHost := re.Match[1] ;
      if re.Match[3] <> '' then proxyPort := re.Match[3] else proxyPort := '80';
    end;
  except
  end;

  if Edit2.Text = '' then
  begin
    proxyHost := '';
    proxyPort := '80';
  end
  else
    StatusBar1.SimpleText  := StatusBar1.SimpleText + ' Proxy: ' + proxyHost + ':' + ProxyPort;

  re.Free;

end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  httpPort := '80';
  proxyPort := '80';
end;

end.
